# The Carto Program (Revive)

This repository contains the source code of The Carto Program, using the [Godot game engine][godot].

## About open-sourcing

Carto may not be the best space simulator out there. It may not be the most performant one, nor the best looking one with AAA graphics, or the most user-friendly one. While we strive to cat not doing exceptionally bad in these fields, in the very heart of this project we want Carto to be the most open one out there.

A space game that's hackable.  
A space game that's yours, and forever yours.

To achieve this goal, Carto is fully open-source with a copyleft license, and is built upon open-source public solutions. You can build the entire game from source, down to every line of the engine and game code.

Feel free to get involved in Carto's development process. Fiddle around with the configuration. Try building the codebase yourself. Make some mods. Reuse our code. Maybe even submitting patches to the main repo. Carto is our project, and also your project. But ultimately, it's yours.

[godot]: https://godotengine.org

## Developing

You would need the following programs installed in your machine to develop Carto:

- [Godot 4.3][godotdownload] with DotNet support.
- The [GodotEnv][godotenv] addon package manager from ChickenSoft.
- DotNet 8+ SDK.

[godotdownload]: https://godotengine.org/download/archive/4.3.0/
[godotenv]: https://github.com/chickensoft-games/GodotEnv

### Preparing the developing environment

After cloning the repository, install the addons with

```sh
godotenv addons install
```

### Building

Building Carto is trivial:

1. Build/export the project of the corresponding target with Godot's built-in export menu.
2. Copy the `gamedata` folder to the target directory, next to the executable.

## License

The Carto codebase is licensed under the [Mozilla Public License, version 2.0][mpl20].
Assets are dual licensed under CC BY-NC-SA 4.0.
Some part of the project may have a more permissive license, see the relevant parts for details.

Copyleft (ɔ) Quadratic Dream & other Carto contributors.

[mpl20]: https://www.mozilla.org/en-US/MPL/2.0/
